; 
    include \masm32\include\masm32rt.inc
    .586
; 
    .data
    .code
; 
start:
; 

    call CpuClockSpeed
    .IF eax
      push  eax
      push  eax
      fstp  QWORD PTR[esp]
      pop   eax
      pop   edx
      invoke crt_printf,chr$("%.2f MHz%c"),edx::eax,10
    .ENDIF  

    inkey "Press any key to exit..."
    exit

; 
; This proc determines the CPU clock speed in MHz by counting TSC
; cycles over a one-second interval timed with the high-resolution
; performance counter. If the processor supports CPUID and RDTSC
; and the system supports a high-resolution performance counter,
; the clock speed is left on the FPU stack in ST(0) and the return
; value is non-zero. Otherwise, the return value is zero.
; 

CpuClockSpeed proc uses edi esi

    LOCAL pcFreq  :QWORD
    LOCAL pcCount :QWORD

    ;-----------------------------------------------------------
    ; CPUID supported if can set/clear ID flag (EFLAGS bit 21).
    ;-----------------------------------------------------------

    pushfd
    pop   edx
    pushfd
    pop   eax
    xor   eax, 200000h  ; flip ID flag
    push  eax
    popfd
    pushfd
    pop   eax
    xor   eax, edx
    jz    fail

    ;------------------------------------------------
    ; TSC supported if CPUID function 1 returns with
    ; bit 4 of EDX set.
    ;------------------------------------------------

    mov   eax, 1
    cpuid
    and   edx, 10h
    jz    fail

    invoke QueryPerformanceFrequency, ADDR pcFreq
    or    eax, eax
    jz    fail
    ;pushad
    ;invoke crt_printf,chr$("pcFreq:%I64d%c"),pcFreq,10
    ;popad

    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, HIGH_PRIORITY_CLASS

    ;----------------------------------------------------
    ; Sync with performance counter and get start count.
    ;----------------------------------------------------

    invoke QueryPerformanceCounter, ADDR pcCount
    mov   edi, DWORD PTR pcCount
  @@:
    invoke QueryPerformanceCounter, ADDR pcCount
    cmp   edi, DWORD PTR pcCount
    je    @B

    rdtsc
    push  edx
    push  eax

    ;-----------------------------------------
    ; Calc terminal count for 1 second delay.
    ;-----------------------------------------

    mov   edi, DWORD PTR pcCount
    mov   esi, DWORD PTR pcCount + 4
    add   edi, DWORD PTR pcFreq    
    adc   esi, DWORD PTR pcFreq + 4

    ;---------------------------------------------
    ; Loop until PC count exceeds terminal count.
    ;
    ; Cannot check low-order dword for equality
    ; because PC cannot be depended on to always
    ; increment count by one.
    ;---------------------------------------------
  @@:  
    invoke QueryPerformanceCounter, ADDR pcCount
    cmp   DWORD PTR pcCount+4, esi
    jne   @B
    cmp   DWORD PTR pcCount, edi
    jb    @B    

    rdtsc
    
    pop   ecx
    sub   eax, ecx
    pop   ecx
    sbb   edx, ecx

    push  edx
    push  eax
    finit
    fild  QWORD PTR[esp]
    fld8  1000000.0
    fdiv

    invoke GetCurrentProcess
    invoke SetPriorityClass, eax, NORMAL_PRIORITY_CLASS

    return 1

  fail:

    return 0

CpuClockSpeed endp

; 

end start
